       identification division.
       program-id. isam-create.
       author. allu.
       date-written. March 2024.
       environment division.
       input-output section.
       file-control.
           select INFILE assign to "aa.txt"
           organization is line sequential
           status is Infile-status.
           select OUTFILE assign to "aa.dat"
           organization is indexed
           access is random
           record key is Outfile-code1
           alternate key is Outfile-code3
           status is Outfile-status.
       data division.
       fd  INFILE.
       01 Infile-record.
         05 Infile-name pic X(13).
         05 filler pic X.
         05 Infile-code3 pic XXX.
         05 filler pic X.
         05 Infile-code1 pic X.
         05 filler pic X.
         05 Infile-formula1 pic X(10).
         05 filler pic X.
         05 Infile-formula2 pic X(32).
       fd  OUTFILE.
       01 Outfile-record.
         05 Outfile-code1 pic X.
         05 Outfile-code3 pic XXX.
         05 Outfile-name pic X(13).
         05 Outfile-formula1 pic X(10).
         05 Outfile-formula2 pic X(32).
       working-storage section.
       77 Record-Count pic 99.
       77 Infile-eof pic 9.
       77 Infile-status pic XX.
       77 Outfile-status pic XX.
       procedure division.
       declaratives.
       Infile-errors section.
           use after error procedure
           on INFILE.
       Infile-error.
           display "Error when reading 'aa.txt': " no advancing.
           display Infile-status.
           stop run.
       Infile-error-out.
           exit.
       Outfile-errors section.
           use after error procedure
           on OUTFILE.
       Outfile-error.
           display "Error when writing 'aa.dat': " no advancing.
           display Outfile-status.
           stop run.
       Outfile-error-out.
           exit.
       end declaratives.
       main section.
           display "Copying 'aa.txt' to 'aa.dat'".
           perform Open-files.
           move 0 to Infile-eof.
           move 0 to Record-Count.
           perform Copy-files until Infile-eof = 1.
           perform Display-count.
           perform Close-files.
           stop run.
       Open-files.
           open input INFILE.
           open output OUTFILE.
       Copy-files.
           read INFILE
               at end
                   move 1 to Infile-eof
               not at end
                   perform Write-file.
       Write-file.
           move Infile-code1 to Outfile-code1.
           move Infile-code3 to Outfile-code3.
           move Infile-name to Outfile-name.
           move Infile-formula1 to Outfile-formula1.
           move Infile-formula2 to Outfile-formula2.
           write Outfile-record.
           add 1 to Record-Count.
       Display-count.
           display "Number of records copied: " no advancing.
           display Record-Count.
       Close-files.
           close INFILE.
           close OUTFILE.
