       identification division.
       program-id. isam-search.
       author. allu.
       date-written. March 2024.
       environment division.
       input-output section.
       file-control.
           select INFILE assign to "aa.dat"
           organization is indexed
           access is random
           record key is Infile-code1
           alternate key is Infile-code3
           status is Infile-status.
       data division.
       fd INFILE.
       01 Infile-record.
         05 Infile-code1 pic X.
         05 Infile-code3 pic XXX.
         05 Infile-name pic X(13).
         05 Infile-formula1 pic X(10).
         05 Infile-formula2 pic X(32).
       working-storage section.
       77 Program-option pic X.
       77 Infile-status pic XX.
       01 Display-line.
         05 Display-code1 pic X.
         05 filler pic XX value spaces.
         05 Display-code3 pic XXX.
         05 filler pic XX value spaces.
         05 Display-name pic X(13).
         05 filler pic XX value spaces.
         05 Display-formula1 pic X(10).
         05 filler pic XX value spaces.
         05 Display-formula2 pic X(32).
       procedure division.
       declaratives.
       Infile-errors section.
           use after error procedure
           on INFILE.
       Infile-error.
           display "Error when reading 'aa.dat': " no advancing.
           display Infile-status.
           stop run.
       Infile-error-out.
           exit.
       end declaratives.
       main section.
           open input INFILE.
           perform Ask-for-option
             until Program-option = "0".
           close INFILE.
           stop run.
       Ask-for-option.
           display "Options: 1=1-letter code, 3=3-letter code ? " no advancing.
           accept Program-option.
           if Program-option = "1"
               perform Search-with-1-letter-code
           else
               if Program-option = "3"
                   perform Search-with-3-letter-code
               else
                   move "0" to Program-option.
       Search-with-1-letter-code.
           display "1-letter AA code ? " no advancing.
           accept Infile-code1.
           read INFILE
               invalid key
                   perform Key-Not-Found
               not invalid key
                   perform Display-record.
       Search-with-3-letter-code.
           display "3-letter AA code ? " no advancing.
           accept Infile-code3.
           read INFILE
               key is Infile-code3
               invalid key
                   perform Key-Not-Found
               not invalid key
                   perform Display-record.
       Display-record.
           move Infile-code1 to Display-code1.
           move Infile-code3 to Display-code3.
           move Infile-name to Display-name.
           move Infile-formula1 to Display-formula1.
           move Infile-formula2 to Display-formula2.
           display Display-line.
       Key-Not-Found.
           display "Invalid or unknown AA code".
